//+------------------------------------------------------------------+
//|                                         EarlyMorningBreakOut.mq4 |
//|                              Copyright 2014, MQL4 Coding Service |
//|                                 http://www.mql4codingservice.com |
//+------------------------------------------------------------------+

// Works on time frames of 60M and smaller.


#property copyright "Copyright 2014, MQL4 Coding Service"
#property link      "http://www.mql4codingservice.com"

extern int         StartHour            = 6;
extern int         HoursLookBack        = 6;
extern double      PipsTreshold         = 5;
extern double      RiskPercentage       = 0.4;
extern int         MagicNumber          =1234;

static double points;

int  pending.buy, pending.sell, market.buy, market.sell; 


int init()
  {
//----
   points = GetPoints();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
 
 
 Count.Orders();

if(Hour()==StartHour && Minute()==0){
   if(pending.buy+pending.sell+ market.buy+ market.sell==0)Place.Pending();
  }

if(pending.buy+pending.sell==1)Delete.Pending(); 


   return(0);
  }
//+------------------------------------------------------------------+

double Support(){
return(Low[iLowest(Symbol(),0,MODE_LOW, (60 / Period()) * HoursLookBack,0)]);  
}

double Resistance(){
return(High[iHighest(Symbol(),0,MODE_HIGH, (60 / Period()) * HoursLookBack,0)]);  
}

double Lot.Size(){
    double pips=((Resistance()-Support())/points )+PipsTreshold; 
    double lot.step  =MarketInfo(Symbol(),MODE_LOTSTEP);
    double min.lot   =MarketInfo(Symbol(),MODE_MINLOT);
    double max.lot   =MarketInfo(Symbol(),MODE_MAXLOT);
    double risk      =AccountBalance()*(RiskPercentage/100);    
    double pip.value =(MarketInfo(Symbol(),MODE_TICKVALUE)/MarketInfo(Symbol(),MODE_TICKSIZE))*points;
    double lot       =(risk/pips) / (pip.value); 
    double lots      =MathFloor(lot/lot.step)*lot.step;
    if (lots<min.lot)lots=min.lot;
    if (lots>max.lot)lots=max.lot;
    return(lots);   
}


void Place.Pending(){

double lot = Lot.Size();

double open.buy        =Resistance()+(PipsTreshold*points);
double tp.buy          =Resistance()+(PipsTreshold*points) +(Resistance()-Support());
double sl.buy          =Support();

double open.sell       =Support()-(PipsTreshold*points);
double tp.sell         =Support()-(PipsTreshold*points) -(Resistance()-Support());
double sl.sell         =Resistance();

OrderSend(Symbol(),OP_BUYSTOP ,lot, open.buy,0,sl.buy,tp.buy,0,MagicNumber,0,0);
OrderSend(Symbol(),OP_SELLSTOP,lot, open.sell,0,sl.sell,tp.sell,0,MagicNumber,0,0);

}

void Delete.Pending(){
int i;
for(i=OrdersTotal()-1;i>=0;i--){
    if(OrderSelect(i,SELECT_BY_POS)){
       if(OrderSymbol()==Symbol()){
           if(OrderMagicNumber()==MagicNumber){
              if(OrderType()>3)OrderDelete(OrderTicket(),0);
}}}}}



void Count.Orders(){
int i;
market.buy=0; market.sell=0; pending.buy=0; pending.sell=0;

for(i=OrdersTotal()-1;i>=0;i--){
    if(OrderSelect(i,SELECT_BY_POS)){
       if(OrderSymbol()==Symbol()){
           if(OrderMagicNumber()==MagicNumber){
         
              if(OrderType()==OP_BUY)      market.buy++;
              if(OrderType()==OP_SELL)     market.sell++;
              if(OrderType()==OP_BUYSTOP)  pending.buy++;
              if(OrderType()==OP_SELLSTOP) pending.sell++;        
}}}}}  

double GetPoints(){
int digits; double pip;
digits = MarketInfo(Symbol(),MODE_DIGITS);                
        if(digits==2||digits==3)pip=0.01;
        else if(digits==4||digits==5)pip=0.0001;
return(pip);
}               